Hardware Locality (hwloc): Interoperability with the NVIDIA Management Library

Hardware Locality (hwloc) 2.9.3

Functions
Interoperability with the NVIDIA Management Library

## Functions
static int | hwloc_nvml_get_device_cpuset (hwloc_topology_t topology, nvmlDevice_t device, hwloc_cpuset_t set)
static hwloc_obj_t | hwloc_nvml_get_device_osdev_by_index (hwloc_topology_t topology, unsigned idx)
static hwloc_obj_t | hwloc_nvml_get_device_osdev (hwloc_topology_t topology, nvmlDevice_t device)

## Detailed Description

This interface offers ways to retrieve topology information about devices managed by the NVIDIA Management Library (NVML).

## Function Documentation

## ◆ hwloc_nvml_get_device_cpuset()

static int hwloc_nvml_get_device_cpuset | ( | hwloc_topology_t | topology,
|  | nvmlDevice_t | device,
|  | hwloc_cpuset_t | set
| ) |  |
| inlinestatic

Get the CPU set of processors that are physically close to NVML device `device`.

Store in `set` the CPU-set describing the locality of the NVML device `device`.

Topology `topology` and device `device` must match the local machine. I/O devices detection and the NVML component are not needed in the topology.

The function only returns the locality of the device. If more information about the device is needed, OS objects should be used instead, see hwloc_nvml_get_device_osdev() and hwloc_nvml_get_device_osdev_by_index().

This function is currently only implemented in a meaningful way for Linux; other systems will simply get a full cpuset.

Returns
  0 on success.
  -1 on error, for instance if device information could not be found.

## ◆ hwloc_nvml_get_device_osdev()

static hwloc_obj_t hwloc_nvml_get_device_osdev | ( | hwloc_topology_t | topology,
|  | nvmlDevice_t | device
| ) |  |
| inlinestatic

Get the hwloc OS device object corresponding to NVML device `device`.

Returns
  The hwloc OS device object that describes the given NVML device `device`.
  `NULL` if none could be found.

Topology `topology` and device `device` must match the local machine. I/O devices detection and the NVML component must be enabled in the topology. If not, the locality of the object may still be found using hwloc_nvml_get_device_cpuset().

Note
  The corresponding hwloc PCI device may be found by looking at the result parent pointer (unless PCI devices are filtered out).

## ◆ hwloc_nvml_get_device_osdev_by_index()

static hwloc_obj_t hwloc_nvml_get_device_osdev_by_index | ( | hwloc_topology_t | topology,
|  | unsigned | idx
| ) |  |
| inlinestatic

Get the hwloc OS device object corresponding to the NVML device whose index is `idx`.

Returns
  The hwloc OS device object describing the NVML device whose index is `idx`.
  `NULL` if none could be found.

The topology `topology` does not necessarily have to match the current machine. For instance the topology may be an XML import of a remote host. I/O devices detection and the NVML component must be enabled in the topology.

Note
  The corresponding PCI device object can be obtained by looking at the OS device parent object (unless PCI devices are filtered out).